from fasthtml.common import *
from fasthtml.svg import *
from monsterui.all import *


def CoreArchitectureChart():
    return Div(
        Div(
            style="max-width:100%;border:1px solid transparent;",
            data_mxgraph='{"highlight":"#0000ff","nav":true,"resize":true,"page":0,"toolbar":"pages zoom layers tags lightbox","edit":"_blank","xml":"<mxfile><diagram id=\\"l7_B5a2V6sOU66k4eApJ\\" name=\\"Core Architecture\\"><mxGraphModel dx=\\"1139\\" dy=\\"934\\" grid=\\"0\\" gridSize=\\"10\\" guides=\\"1\\" tooltips=\\"1\\" connect=\\"1\\" arrows=\\"1\\" fold=\\"1\\" page=\\"1\\" pageScale=\\"1\\" pageWidth=\\"850\\" pageHeight=\\"1100\\" background=\\"#FFFFFF\\" math=\\"0\\" shadow=\\"1\\"><root><mxCell id=\\"0\\"/><mxCell id=\\"1\\" parent=\\"0\\"/><mxCell id=\\"3\\" value=\\"graph TB&#10;    subgraph User Application&#10;        UA[User Code] --&gt; |Uses| SM[Flock Manager]&#10;    end&#10;&#10;    subgraph Flock Core&#10;        SM --&gt; |Manages| AR[Agent Registry]&#10;        SM --&gt; |Executes| WF[Workflow System]&#10;        &#10;        subgraph Agents&#10;            AR --&gt; |Registers| DA[Declarative Agent]&#10;            DA --&gt; |Uses| TS[Type System]&#10;            DA --&gt; |Uses| TM[Tool Manager]&#10;        end&#10;        &#10;        subgraph Workflow&#10;            WF --&gt; |Runs| AC[Activities]&#10;            WF --&gt; |Uses| TW[Temporal Worker]&#10;            AC --&gt; |Executes| DA&#10;        end&#10;    end&#10;&#10;    subgraph External Systems&#10;        TW --&gt; |Connects to| TS1[Temporal Server]&#10;        TM --&gt; |Integrates| T1[Web Search]&#10;        TM --&gt; |Integrates| T2[Code Eval]&#10;        TM --&gt; |Integrates| T3[Math Tools]&#10;        DA --&gt; |Uses| LLM[LLM Provider]&#10;    end&#10;&#10;    classDef core fill:#f9f,stroke:#333,stroke-width:2px&#10;    classDef external fill:#bbf,stroke:#333,stroke-width:2px&#10;    classDef user fill:#bfb,stroke:#333,stroke-width:2px&#10;    &#10;    class SM,AR,DA,WF,AC,TM,TS core&#10;    class TS1,T1,T2,T3,LLM external&#10;    class UA user&#10;&#10;\\" style=\\"shadow=0;dashed=0;align=left;strokeWidth=1;shape=mxgraph.mermaid.abstract.mermaid;labelBackgroundColor=#ffffff;noLabel=1;theme=default;rounded=1;\\" parent=\\"1\\" vertex=\\"1\\"><mxGeometry x=\\"200\\" y=\\"310\\" width=\\"300\\" height=\\"300\\" as=\\"geometry\\"/></mxCell></root></mxGraphModel></diagram><diagram id=\\"m33Os__FMXyp1zJ4IDTH\\" name=\\"Agent Workflow\\"><mxGraphModel dx=\\"1139\\" dy=\\"934\\" grid=\\"0\\" gridSize=\\"10\\" guides=\\"1\\" tooltips=\\"1\\" connect=\\"1\\" arrows=\\"1\\" fold=\\"1\\" page=\\"1\\" pageScale=\\"1\\" pageWidth=\\"850\\" pageHeight=\\"1100\\" background=\\"#ffffff\\" math=\\"0\\" shadow=\\"1\\"><root><mxCell id=\\"0\\"/><mxCell id=\\"1\\" parent=\\"0\\"/><mxCell id=\\"Yf0mmGmI6B4_u023lZ5C-1\\" value=\\"sequenceDiagram&#10;    participant User&#10;    participant Flock&#10;    participant Agent&#10;    participant Tools&#10;    participant LLM&#10;    participant Temporal&#10;&#10;    User-&gt;&gt;Flock: Create Agent&#10;    Flock-&gt;&gt;Agent: Initialize&#10;    User-&gt;&gt;Flock: activate(agent, input)&#10;    &#10;    alt Local Debug Mode&#10;        Flock-&gt;&gt;Agent: Execute Directly&#10;    else Production Mode&#10;        Flock-&gt;&gt;Temporal: Start Workflow&#10;        Temporal-&gt;&gt;Agent: Execute via Activity&#10;    end&#10;&#10;    loop Agent Execution&#10;        Agent-&gt;&gt;LLM: Process Input&#10;        opt Tool Usage&#10;            Agent-&gt;&gt;Tools: Execute Tool&#10;            Tools--&gt;&gt;Agent: Tool Result&#10;        end&#10;        Agent-&gt;&gt;LLM: Generate Output&#10;    end&#10;&#10;    alt Has Hand-off&#10;        Agent-&gt;&gt;Flock: Hand off to Next Agent&#10;        Flock-&gt;&gt;Agent: Start Next Agent&#10;    else No Hand-off&#10;        Agent--&gt;&gt;Flock: Return Result&#10;    end&#10;&#10;    Flock--&gt;&gt;User: Return Final Result\\" style=\\"shadow=0;dashed=0;align=left;strokeWidth=1;shape=mxgraph.mermaid.abstract.mermaid;labelBackgroundColor=#ffffff;noLabel=1;theme=default;\\" parent=\\"1\\" vertex=\\"1\\"><mxGeometry x=\\"275\\" y=\\"114\\" width=\\"300\\" height=\\"300\\" as=\\"geometry\\"/></mxCell></root></mxGraphModel></diagram><diagram id=\\"zsmzvY-bLYlccnSXdfzv\\" name=\\"Temporal Workflow\\">\\n        <mxGraphModel dx=\\"205\\" dy=\\"165\\" grid=\\"0\\" gridSize=\\"10\\" guides=\\"1\\" tooltips=\\"1\\" connect=\\"1\\" arrows=\\"1\\" fold=\\"1\\" page=\\"1\\" pageScale=\\"1\\" pageWidth=\\"850\\" pageHeight=\\"1100\\" background=\\"#ffffff\\" math=\\"0\\" shadow=\\"1\\">\\n            <root>\\n                <mxCell id=\\"0\\"/>\\n                <mxCell id=\\"1\\" parent=\\"0\\"/>\\n                <mxCell id=\\"LGo0nXY-PDX6Si-UCiUW-1\\" value=\\"graph TB&#10;    subgraph Temporal Integration&#10;        WF[Workflow System] --&gt; |Manages| TW[Temporal Worker]&#10;        TW --&gt; |Executes| AC[Activities]&#10;        TW --&gt; |Connects to| TS[Temporal Server]&#10;        &#10;        subgraph State Management&#10;            TS --&gt; |Manages| WS[Workflow State]&#10;            WS --&gt; |Tracks| AS[Agent State]&#10;            WS --&gt; |Tracks| TS1[Tool State]&#10;            WS --&gt; |Tracks| ES[Error State]&#10;        end&#10;&#10;        subgraph Reliability Features&#10;            TS --&gt; |Provides| R1[Automatic Retries]&#10;            TS --&gt; |Provides| R2[Error Recovery]&#10;            TS --&gt; |Provides| R3[State Persistence]&#10;            TS --&gt; |Provides| R4[Workflow History]&#10;        end&#10;&#10;        subgraph Monitoring&#10;            TS --&gt; |Enables| M1[Execution Metrics]&#10;            TS --&gt; |Enables| M2[Error Tracking]&#10;            TS --&gt; |Enables| M3[Performance Stats]&#10;            TS --&gt; |Enables| M4[Workflow Visualization]&#10;        end&#10;    end&#10;&#10;    classDef core fill:#f9f,stroke:#333,stroke-width:2px&#10;    classDef state fill:#bbf,stroke:#333,stroke-width:2px&#10;    classDef feature fill:#bfb,stroke:#333,stroke-width:2px&#10;    classDef monitor fill:#fbb,stroke:#333,stroke-width:2px&#10;&#10;    class WF,TW,AC,TS core&#10;    class WS,AS,TS1,ES state&#10;    class R1,R2,R3,R4 feature&#10;    class M1,M2,M3,M4 monitor&#10;&#10;\\" style=\\"shadow=0;dashed=0;align=left;strokeWidth=1;shape=mxgraph.mermaid.abstract.mermaid;labelBackgroundColor=#ffffff;noLabel=1;theme=default;\\" vertex=\\"1\\" parent=\\"1\\">\\n                    <mxGeometry x=\\"242\\" y=\\"169\\" width=\\"300\\" height=\\"300\\" as=\\"geometry\\"/>\\n                </mxCell>\\n            </root>\\n        </mxGraphModel>\\n    </diagram><diagram id=\\"FU8wRJNSLGF58lYnAYQQ\\" name=\\"Tool System\\">\\n        <mxGraphModel dx=\\"307\\" dy=\\"248\\" grid=\\"0\\" gridSize=\\"10\\" guides=\\"1\\" tooltips=\\"1\\" connect=\\"1\\" arrows=\\"1\\" fold=\\"1\\" page=\\"1\\" pageScale=\\"1\\" pageWidth=\\"850\\" pageHeight=\\"1100\\" background=\\"#ffffff\\" math=\\"0\\" shadow=\\"1\\">\\n            <root>\\n                <mxCell id=\\"0\\"/>\\n                <mxCell id=\\"1\\" parent=\\"0\\"/>\\n                <mxCell id=\\"T-pgXY2fyKOihok5m5tA-1\\" value=\\"graph TB&#10;    subgraph Tool Management&#10;        TM[Tool Manager] --&gt; |Manages| TR[Tool Registry]&#10;        TR --&gt; |Registers| T1[Web Search Tool]&#10;        TR --&gt; |Registers| T2[Code Eval Tool]&#10;        TR --&gt; |Registers| T3[Math Tool]&#10;        &#10;        TM --&gt; |Provides| TI[Tool Interface]&#10;        TI --&gt; |Used by| DA[Declarative Agent]&#10;    end&#10;&#10;    subgraph Tool Execution&#10;        T1 --&gt; |Uses| WS[Web Search API]&#10;        T2 --&gt; |Uses| CE[Code Executor]&#10;        T3 --&gt; |Uses| ME[Math Engine]&#10;        &#10;        WS --&gt; |Returns| R1[Search Results]&#10;        CE --&gt; |Returns| R2[Execution Results]&#10;        ME --&gt; |Returns| R3[Math Results]&#10;    end&#10;&#10;    subgraph Error Handling&#10;        TM --&gt; |Manages| EH[Error Handler]&#10;        EH --&gt; |Handles| E1[API Errors]&#10;        EH --&gt; |Handles| E2[Execution Errors]&#10;        EH --&gt; |Handles| E3[Validation Errors]&#10;    end&#10;&#10;    classDef core fill:#f9f,stroke:#333,stroke-width:2px&#10;    classDef tool fill:#bbf,stroke:#333,stroke-width:2px&#10;    classDef handler fill:#bfb,stroke:#333,stroke-width:2px&#10;&#10;    class TM,TR,TI core&#10;    class T1,T2,T3,WS,CE,ME tool&#10;    class EH,E1,E2,E3 handler\\" style=\\"shadow=0;dashed=0;align=left;strokeWidth=1;shape=mxgraph.mermaid.abstract.mermaid;labelBackgroundColor=#ffffff;noLabel=1;theme=default;\\" vertex=\\"1\\" parent=\\"1\\">\\n                    <mxGeometry x=\\"240\\" y=\\"170\\" width=\\"300\\" height=\\"300\\" as=\\"geometry\\"/>\\n                </mxCell>\\n            </root>\\n        </mxGraphModel>\\n    </diagram><diagram id=\\"44PLLl0pgulDx2n2xTWC\\" name=\\"Type System\\">\\n        <mxGraphModel dx=\\"767\\" dy=\\"620\\" grid=\\"0\\" gridSize=\\"10\\" guides=\\"1\\" tooltips=\\"1\\" connect=\\"1\\" arrows=\\"1\\" fold=\\"1\\" page=\\"1\\" pageScale=\\"1\\" pageWidth=\\"850\\" pageHeight=\\"1100\\" background=\\"#ffffff\\" math=\\"0\\" shadow=\\"1\\">\\n            <root>\\n                <mxCell id=\\"0\\"/>\\n                <mxCell id=\\"1\\" parent=\\"0\\"/>\\n                <mxCell id=\\"jTONh3Pudjw2xIwc2DDu-1\\" value=\\"classDiagram&#10;    class TypeSystem {&#10;        +register_type(name, validator, serializer)&#10;        +validate(value, type_def)&#10;        +parse_type_string(type_str)&#10;        -_validate_complex_type(value, type_def)&#10;    }&#10;&#10;    class TypeDefinition {&#10;        +name: str&#10;        +validators: List&#10;        +serializers: Optional&#10;        +validate(value)&#10;        +serialize(value)&#10;    }&#10;&#10;    class DeclarativeAgent {&#10;        +input: str&#10;        +output: str&#10;        +tools: List&#10;        +validate_input(value)&#10;        +validate_output(value)&#10;    }&#10;&#10;    class Validator {&#10;        +validate(value)&#10;        +coerce(value)&#10;    }&#10;&#10;    TypeSystem --&gt; TypeDefinition : manages&#10;    DeclarativeAgent --&gt; TypeSystem : uses&#10;    TypeDefinition --&gt; Validator : uses&#10;&#10;\\" style=\\"shadow=0;dashed=0;align=left;strokeWidth=1;shape=mxgraph.mermaid.abstract.mermaid;labelBackgroundColor=#ffffff;noLabel=1;theme=default;\\" vertex=\\"1\\" parent=\\"1\\">\\n                    <mxGeometry x=\\"242\\" y=\\"169\\" width=\\"300\\" height=\\"300\\" as=\\"geometry\\"/>\\n                </mxCell>\\n            </root>\\n        </mxGraphModel>\\n    </diagram></mxfile>"}',
            cls="mxgraph",
        ),
        Script(type="text/javascript", src="https://viewer.diagrams.net/js/viewer-static.min.js"),
    )
